diff --git a/src/Directory.Build.props b/src/Directory.Build.props
index b7d39cc6f5..ce54e08edd 100644
--- a/src/Directory.Build.props
+++ b/src/Directory.Build.props
@@ -42,4 +42,12 @@
   <PropertyGroup Condition="'$(TF_BUILD)' == 'true'">
     <ContinuousIntegrationBuild>true</ContinuousIntegrationBuild>
   </PropertyGroup>
+
+  <!-- Package Validation -->
+  <PropertyGroup>
+    <EnablePackageValidation>true</EnablePackageValidation>
+    <PackageValidationBaselineVersion>10.0.0</PackageValidationBaselineVersion>
+    <EnableStrictModeForCompatibleFrameworksInPackage>true</EnableStrictModeForCompatibleFrameworksInPackage>
+    <EnableStrictModeForCompatibleTfms>true</EnableStrictModeForCompatibleTfms>
+  </PropertyGroup>
 </Project>
diff --git a/src/JsonSchema/JsonSchema.csproj b/src/JsonSchema/JsonSchema.csproj
index 5ab8db1d99..ea0ce9b7c3 100644
--- a/src/JsonSchema/JsonSchema.csproj
+++ b/src/JsonSchema/JsonSchema.csproj
@@ -4,6 +4,7 @@
     <TargetFramework>net6.0</TargetFramework>
     <GenerateDocumentationFile>true</GenerateDocumentationFile>
     <IsPackable>false</IsPackable>
+    <EnablePackageValidation>false</EnablePackageValidation>
   </PropertyGroup>
 
     <ItemGroup>
@@ -34,5 +35,4 @@
     </ItemGroup>
     <Copy SourceFiles="@(PackageReferenceFiles)" DestinationFolder="$(OutDir)" />
   </Target>
-
 </Project>
diff --git a/src/Umbraco.Cms.StaticAssets/umbraco/UmbracoInstall/Index.cshtml b/src/Umbraco.Cms.StaticAssets/umbraco/UmbracoInstall/Index.cshtml
index 92e458c3b0..406c311312 100644
--- a/src/Umbraco.Cms.StaticAssets/umbraco/UmbracoInstall/Index.cshtml
+++ b/src/Umbraco.Cms.StaticAssets/umbraco/UmbracoInstall/Index.cshtml
@@ -26,7 +26,7 @@
 
     <div id="overlay" ng-cloak ng-animate="'fade'" ng-show="installer.done"></div>
 
-    <div id="installer" class="absolute-center clearfix"
+    <div id="installer"
          ng-cloak
          ng-animate="'fade'"
          ng-show="installer.configuring">
diff --git a/src/Umbraco.Cms.StaticAssets/umbraco/UmbracoWebsite/NoNodes.cshtml b/src/Umbraco.Cms.StaticAssets/umbraco/UmbracoWebsite/NoNodes.cshtml
index 69d8318a1f..e773e81516 100644
--- a/src/Umbraco.Cms.StaticAssets/umbraco/UmbracoWebsite/NoNodes.cshtml
+++ b/src/Umbraco.Cms.StaticAssets/umbraco/UmbracoWebsite/NoNodes.cshtml
@@ -36,10 +36,10 @@
 
                 <div class="row">
                     <div class="col">
-                        <h2>Easy start with Umbraco.tv</h2>
+                        <h2>Easy start with Umbraco Learning Base</h2>
                         <p>We have created a bunch of 'how-to' videos, to get you easily started with Umbraco. Learn how to build projects in just a couple of minutes. Easiest CMS in the world.</p>
 
-                        <a href="https://umbraco.tv?ref=tvFromInstaller" target="_blank" rel="noopener">Umbraco.tv &rarr;</a>
+                        <a href="https://www.youtube.com/channel/UCbGfwSAPflebnadyhEPw-wA?ref=tvFromInstaller" target="_blank" rel="noopener">Umbraco Learning Base &rarr;</a>
                     </div>
 
                     <div class="col">
diff --git a/src/Umbraco.Core/Actions/ActionAssignDomain.cs b/src/Umbraco.Core/Actions/ActionAssignDomain.cs
index b8fd8a4650..3bd946837f 100644
--- a/src/Umbraco.Core/Actions/ActionAssignDomain.cs
+++ b/src/Umbraco.Core/Actions/ActionAssignDomain.cs
@@ -24,7 +24,7 @@ public class ActionAssignDomain : IAction
     public string Category => Constants.Conventions.PermissionCategories.AdministrationCategory;
 
     /// <inheritdoc />
-    public string Icon => "home";
+    public string Icon => "icon-home";
 
     /// <inheritdoc />
     public bool ShowInNotifier => false;
diff --git a/src/Umbraco.Core/Actions/ActionCopy.cs b/src/Umbraco.Core/Actions/ActionCopy.cs
index 02bb17166f..f7d9d699a5 100644
--- a/src/Umbraco.Core/Actions/ActionCopy.cs
+++ b/src/Umbraco.Core/Actions/ActionCopy.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionCopy : IAction
     public string Category => Constants.Conventions.PermissionCategories.StructureCategory;
 
     /// <inheritdoc />
-    public string Icon => "documents";
+    public string Icon => "icon-documents";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionCreateBlueprintFromContent.cs b/src/Umbraco.Core/Actions/ActionCreateBlueprintFromContent.cs
index 85490b42f8..ee249d9ef8 100644
--- a/src/Umbraco.Core/Actions/ActionCreateBlueprintFromContent.cs
+++ b/src/Umbraco.Core/Actions/ActionCreateBlueprintFromContent.cs
@@ -18,7 +18,7 @@ public class ActionCreateBlueprintFromContent : IAction
     public bool CanBePermissionAssigned => true;
 
     /// <inheritdoc />
-    public string Icon => "blueprint";
+    public string Icon => Constants.Icons.Blueprint;
 
     /// <inheritdoc />
     public string Alias => "createblueprint";
diff --git a/src/Umbraco.Core/Actions/ActionDelete.cs b/src/Umbraco.Core/Actions/ActionDelete.cs
index 7d9c4e6a03..055b2a8f98 100644
--- a/src/Umbraco.Core/Actions/ActionDelete.cs
+++ b/src/Umbraco.Core/Actions/ActionDelete.cs
@@ -28,7 +28,7 @@ public class ActionDelete : IAction
     public string Category => Constants.Conventions.PermissionCategories.ContentCategory;
 
     /// <inheritdoc/>
-    public string Icon => "delete";
+    public string Icon => "icon-delete";
 
     /// <inheritdoc/>
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionMove.cs b/src/Umbraco.Core/Actions/ActionMove.cs
index a40d03d096..c1f6089793 100644
--- a/src/Umbraco.Core/Actions/ActionMove.cs
+++ b/src/Umbraco.Core/Actions/ActionMove.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionMove : IAction
     public string Category => Constants.Conventions.PermissionCategories.StructureCategory;
 
     /// <inheritdoc />
-    public string Icon => "enter";
+    public string Icon => "icon-enter";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionNew.cs b/src/Umbraco.Core/Actions/ActionNew.cs
index 31056632ed..bd08a95ac5 100644
--- a/src/Umbraco.Core/Actions/ActionNew.cs
+++ b/src/Umbraco.Core/Actions/ActionNew.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -25,7 +25,7 @@ public class ActionNew : IAction
     public string Alias => ActionAlias;
 
     /// <inheritdoc />
-    public string Icon => "add";
+    public string Icon => "icon-add";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionNotify.cs b/src/Umbraco.Core/Actions/ActionNotify.cs
index 9d1975b852..10845b01b9 100644
--- a/src/Umbraco.Core/Actions/ActionNotify.cs
+++ b/src/Umbraco.Core/Actions/ActionNotify.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -18,7 +18,7 @@ public class ActionNotify : IAction
     public bool CanBePermissionAssigned => true;
 
     /// <inheritdoc />
-    public string Icon => "megaphone";
+    public string Icon => "icon-megaphone";
 
     /// <inheritdoc />
     public string Alias => "notify";
diff --git a/src/Umbraco.Core/Actions/ActionProtect.cs b/src/Umbraco.Core/Actions/ActionProtect.cs
index 0a5ac8ace8..7b54a0ec98 100644
--- a/src/Umbraco.Core/Actions/ActionProtect.cs
+++ b/src/Umbraco.Core/Actions/ActionProtect.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionProtect : IAction
     public string Category => Constants.Conventions.PermissionCategories.AdministrationCategory;
 
     /// <inheritdoc />
-    public string Icon => "lock";
+    public string Icon => "icon-lock";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionRestore.cs b/src/Umbraco.Core/Actions/ActionRestore.cs
index 79e00f4464..395c678fe4 100644
--- a/src/Umbraco.Core/Actions/ActionRestore.cs
+++ b/src/Umbraco.Core/Actions/ActionRestore.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionRestore : IAction
     public string? Category => null;
 
     /// <inheritdoc />
-    public string Icon => "undo";
+    public string Icon => "icon-undo";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionRights.cs b/src/Umbraco.Core/Actions/ActionRights.cs
index 08afe7e2db..4cd8674122 100644
--- a/src/Umbraco.Core/Actions/ActionRights.cs
+++ b/src/Umbraco.Core/Actions/ActionRights.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionRights : IAction
     public string Category => Constants.Conventions.PermissionCategories.ContentCategory;
 
     /// <inheritdoc />
-    public string Icon => "vcard";
+    public string Icon => "icon-vcard";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionRollback.cs b/src/Umbraco.Core/Actions/ActionRollback.cs
index 5aada555d3..63021a2ae3 100644
--- a/src/Umbraco.Core/Actions/ActionRollback.cs
+++ b/src/Umbraco.Core/Actions/ActionRollback.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionRollback : IAction
     public string Category => Constants.Conventions.PermissionCategories.AdministrationCategory;
 
     /// <inheritdoc />
-    public string Icon => "undo";
+    public string Icon => "icon-undo";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionSort.cs b/src/Umbraco.Core/Actions/ActionSort.cs
index b77a44c730..23e65d7533 100644
--- a/src/Umbraco.Core/Actions/ActionSort.cs
+++ b/src/Umbraco.Core/Actions/ActionSort.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionSort : IAction
     public string Category => Constants.Conventions.PermissionCategories.StructureCategory;
 
     /// <inheritdoc />
-    public string Icon => "navigation-vertical";
+    public string Icon => "icon-navigation-vertical";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionToPublish.cs b/src/Umbraco.Core/Actions/ActionToPublish.cs
index bf15ee4e3b..8df53b3e4a 100644
--- a/src/Umbraco.Core/Actions/ActionToPublish.cs
+++ b/src/Umbraco.Core/Actions/ActionToPublish.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionToPublish : IAction
     public string Category => Constants.Conventions.PermissionCategories.ContentCategory;
 
     /// <inheritdoc />
-    public string Icon => "outbox";
+    public string Icon => "icon-outbox";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Actions/ActionUnpublish.cs b/src/Umbraco.Core/Actions/ActionUnpublish.cs
index c8a83f002e..f8ebb918f9 100644
--- a/src/Umbraco.Core/Actions/ActionUnpublish.cs
+++ b/src/Umbraco.Core/Actions/ActionUnpublish.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionUnpublish : IAction
     public string Category => Constants.Conventions.PermissionCategories.ContentCategory;
 
     /// <inheritdoc />
-    public string Icon => "circle-dotted";
+    public string Icon => "icon-circle-dotted";
 
     /// <inheritdoc />
     public bool ShowInNotifier => false;
diff --git a/src/Umbraco.Core/Actions/ActionUpdate.cs b/src/Umbraco.Core/Actions/ActionUpdate.cs
index 4af2410cc4..2d01ef176c 100644
--- a/src/Umbraco.Core/Actions/ActionUpdate.cs
+++ b/src/Umbraco.Core/Actions/ActionUpdate.cs
@@ -1,4 +1,4 @@
-// Copyright (c) Umbraco.
+﻿// Copyright (c) Umbraco.
 // See LICENSE for more details.
 
 namespace Umbraco.Cms.Core.Actions;
@@ -23,7 +23,7 @@ public class ActionUpdate : IAction
     public string Category => Constants.Conventions.PermissionCategories.ContentCategory;
 
     /// <inheritdoc />
-    public string Icon => "save";
+    public string Icon => "icon-save";
 
     /// <inheritdoc />
     public bool ShowInNotifier => true;
diff --git a/src/Umbraco.Core/Constants-Telemetry.cs b/src/Umbraco.Core/Constants-Telemetry.cs
index 5f3783a774..c40df0f8bd 100644
--- a/src/Umbraco.Core/Constants-Telemetry.cs
+++ b/src/Umbraco.Core/Constants-Telemetry.cs
@@ -1,4 +1,4 @@
-namespace Umbraco.Cms.Core;
+﻿namespace Umbraco.Cms.Core;
 
 public static partial class Constants
 {
@@ -26,5 +26,6 @@ public static partial class Constants
         public static string AspEnvironment = "AspEnvironment";
         public static string IsDebug = "IsDebug";
         public static string DatabaseProvider = "DatabaseProvider";
+        public static string CurrentServerRole = "CurrentServerRole";
     }
 }
diff --git a/src/Umbraco.Core/DependencyInjection/UmbracoBuilder.CollectionBuilders.cs b/src/Umbraco.Core/DependencyInjection/UmbracoBuilder.CollectionBuilders.cs
index bd8114bab9..c409a849ec 100644
--- a/src/Umbraco.Core/DependencyInjection/UmbracoBuilder.CollectionBuilders.cs
+++ b/src/Umbraco.Core/DependencyInjection/UmbracoBuilder.CollectionBuilders.cs
@@ -84,7 +84,7 @@ public static partial class UmbracoBuilderExtensions
         return builder;
     }
 
-    [Obsolete("Use AddEmbedProvider instead. This will be removed in Umbraco 10")]
+    [Obsolete("Use AddEmbedProvider instead. This will be removed in Umbraco 11")]
     public static IUmbracoBuilder AddOEmbedProvider<T>(this IUmbracoBuilder builder)
         where T : class, IEmbedProvider => AddEmbedProvider<T>(builder);
 
diff --git a/src/Umbraco.Core/DependencyInjection/UmbracoBuilder.Collections.cs b/src/Umbraco.Core/DependencyInjection/UmbracoBuilder.Collections.cs
index 5ad759de68..c699e09743 100644
--- a/src/Umbraco.Core/DependencyInjection/UmbracoBuilder.Collections.cs
+++ b/src/Umbraco.Core/DependencyInjection/UmbracoBuilder.Collections.cs
@@ -204,20 +204,12 @@ public static partial class UmbracoBuilderExtensions
         => builder.WithCollectionBuilder<DashboardCollectionBuilder>();
 
     /// <summary>
-    /// Gets the partial view snippets collection builder.
-    /// </summary>
-    /// <param name="builder">The builder.</param>
     public static PartialViewSnippetCollectionBuilder? PartialViewSnippets(this IUmbracoBuilder builder)
         => builder.WithCollectionBuilder<PartialViewSnippetCollectionBuilder>();
 
-    /// <summary>
-    /// Gets the partial view macro snippets collection builder.
-    /// </summary>
-    /// <param name="builder">The builder.</param>
     public static PartialViewMacroSnippetCollectionBuilder? PartialViewMacroSnippets(this IUmbracoBuilder builder)
         => builder.WithCollectionBuilder<PartialViewMacroSnippetCollectionBuilder>();
 
-    /// <summary>
     /// Gets the cache refreshers collection builder.
     /// </summary>
     /// <param name="builder">The builder.</param>
diff --git a/src/Umbraco.Core/FireAndForgetRunner.cs b/src/Umbraco.Core/FireAndForgetRunner.cs
new file mode 100644
index 0000000000..8c466bd439
--- /dev/null
+++ b/src/Umbraco.Core/FireAndForgetRunner.cs
@@ -0,0 +1,41 @@
+﻿using Microsoft.Extensions.Logging;
+
+namespace Umbraco.Cms.Core;
+
+
+public class FireAndForgetRunner : IFireAndForgetRunner
+{
+    private readonly ILogger<FireAndForgetRunner> _logger;
+
+    public FireAndForgetRunner(ILogger<FireAndForgetRunner> logger) => _logger = logger;
+
+    public void RunFireAndForget(Func<Task> task) => ExecuteBackgroundTask(task);
+
+    private Task ExecuteBackgroundTask(Func<Task> fn)
+    {
+        // it is also possible to use UnsafeQueueUserWorkItem which does not flow the execution context,
+        // however that seems more difficult to use for async operations.
+
+        // Do not flow AsyncLocal to the child thread
+        using (ExecutionContext.SuppressFlow())
+        {
+            // NOTE: ConfigureAwait(false) is irrelevant here, it is not needed because this is not being
+            // awaited. ConfigureAwait(false) is only relevant when awaiting to prevent the SynchronizationContext
+            // (very different from the ExecutionContext!) from running the continuation on the calling thread.
+            return Task.Run(LoggingWrapper(fn));
+        }
+    }
+
+    private Func<Task> LoggingWrapper(Func<Task> fn) =>
+        async () =>
+        {
+            try
+            {
+                await fn();
+            }
+            catch (Exception e)
+            {
+                _logger.LogError(e, "Exception thrown in a background thread");
+            }
+        };
+}
diff --git a/src/Umbraco.Core/IFireAndForgetRunner.cs b/src/Umbraco.Core/IFireAndForgetRunner.cs
new file mode 100644
index 0000000000..b28a777990
--- /dev/null
+++ b/src/Umbraco.Core/IFireAndForgetRunner.cs
@@ -0,0 +1,6 @@
+﻿namespace Umbraco.Cms.Core;
+
+public interface IFireAndForgetRunner
+{
+    void RunFireAndForget(Func<Task> task);
+}
diff --git a/src/Umbraco.Core/Models/DictionaryImportModel.cs b/src/Umbraco.Core/Models/DictionaryImportModel.cs
new file mode 100644
index 0000000000..2507a6a1ec
--- /dev/null
+++ b/src/Umbraco.Core/Models/DictionaryImportModel.cs
@@ -0,0 +1,14 @@
+using System.Runtime.Serialization;
+
+namespace Umbraco.Cms.Core.Models
+{
+    [DataContract(Name = "dictionaryImportModel")]
+    public class DictionaryImportModel
+    {
+        [DataMember(Name = "dictionaryItems")]
+        public List<DictionaryPreviewImportModel>? DictionaryItems { get; set; }
+
+        [DataMember(Name = "tempFileName")]
+        public string? TempFileName { get; set; }
+    }
+}
diff --git a/src/Umbraco.Core/Models/DictionaryPreviewImportModel.cs b/src/Umbraco.Core/Models/DictionaryPreviewImportModel.cs
new file mode 100644
index 0000000000..530d49b013
--- /dev/null
+++ b/src/Umbraco.Core/Models/DictionaryPreviewImportModel.cs
@@ -0,0 +1,14 @@
+using System.Runtime.Serialization;
+
+namespace Umbraco.Cms.Core.Models
+{
+    [DataContract(Name = "dictionaryPreviewImportModel")]
+    public class DictionaryPreviewImportModel
+    {
+        [DataMember(Name = "name")]
+        public string? Name { get; set; }
+
+        [DataMember(Name = "level")]
+        public int Level { get; set; }
+    }
+}
diff --git a/src/Umbraco.Core/Models/Property.cs b/src/Umbraco.Core/Models/Property.cs
index 195772be3a..e49edc9217 100644
--- a/src/Umbraco.Core/Models/Property.cs
+++ b/src/Umbraco.Core/Models/Property.cs
@@ -1,4 +1,4 @@
-using System.Collections;
+﻿using System.Collections;
 using System.Runtime.Serialization;
 using Umbraco.Cms.Core.Collections;
 using Umbraco.Cms.Core.Models.Entities;
@@ -198,8 +198,8 @@ public class Property : EntityBase, IProperty
         // and match the specified culture and segment (or anything when '*').
         IEnumerable<IPropertyValue> pvalues = _vvalues.Where(x =>
                 PropertyType.SupportsVariation(x.Value.Culture, x.Value.Segment, true) && // the value variation is ok
-                (culture == "*" || (x.Value.Culture?.InvariantEquals(culture) ?? false)) && // the culture matches
-                (segment == "*" || (x.Value.Segment?.InvariantEquals(segment) ?? false))) // the segment matches
+                    (culture == "*" || x.Value.Culture.InvariantEquals(culture)) && // the culture matches
+                    (segment == "*" || x.Value.Segment.InvariantEquals(segment))) // the segment matches
             .Select(x => x.Value);
 
         foreach (IPropertyValue pvalue in pvalues)
diff --git a/src/Umbraco.Core/Models/Trees/ActionMenuItem.cs b/src/Umbraco.Core/Models/Trees/ActionMenuItem.cs
index 87fe72a0fb..7fdcc4f76f 100644
--- a/src/Umbraco.Core/Models/Trees/ActionMenuItem.cs
+++ b/src/Umbraco.Core/Models/Trees/ActionMenuItem.cs
@@ -1,4 +1,4 @@
-using Umbraco.Cms.Core.Services;
+﻿using Umbraco.Cms.Core.Services;
 using Umbraco.Extensions;
 
 namespace Umbraco.Cms.Core.Models.Trees;
diff --git a/src/Umbraco.Core/Models/Trees/CreateChildEntity.cs b/src/Umbraco.Core/Models/Trees/CreateChildEntity.cs
index 41c8c6f0de..7b3d8f2932 100644
--- a/src/Umbraco.Core/Models/Trees/CreateChildEntity.cs
+++ b/src/Umbraco.Core/Models/Trees/CreateChildEntity.cs
@@ -1,26 +1,30 @@
-using Umbraco.Cms.Core.Actions;
+﻿using Umbraco.Cms.Core.Actions;
 using Umbraco.Cms.Core.Services;
 
 namespace Umbraco.Cms.Core.Models.Trees;
 
 /// <summary>
-///     Represents the refresh node menu item
+    /// Represents the refresh node menu item
 /// </summary>
 public sealed class CreateChildEntity : ActionMenuItem
 {
+    private const string icon = "icon-add";
+
     public CreateChildEntity(string name, bool separatorBefore = false)
         : base(ActionNew.ActionAlias, name)
     {
-        Icon = "add";
+        Icon = icon;
         Name = name;
         SeparatorBefore = separatorBefore;
+        UseLegacyIcon = false;
     }
 
     public CreateChildEntity(ILocalizedTextService textService, bool separatorBefore = false)
         : base(ActionNew.ActionAlias, textService)
     {
-        Icon = "add";
+        Icon = icon;
         SeparatorBefore = separatorBefore;
+        UseLegacyIcon = false;
     }
 
     public override string AngularServiceName => "umbracoMenuActions";
diff --git a/src/Umbraco.Core/Models/Trees/ExportMember.cs b/src/Umbraco.Core/Models/Trees/ExportMember.cs
index 3f11ef4b05..2039a827cf 100644
--- a/src/Umbraco.Core/Models/Trees/ExportMember.cs
+++ b/src/Umbraco.Core/Models/Trees/ExportMember.cs
@@ -1,4 +1,4 @@
-using Umbraco.Cms.Core.Services;
+﻿using Umbraco.Cms.Core.Services;
 
 namespace Umbraco.Cms.Core.Models.Trees;
 
@@ -8,7 +8,11 @@ namespace Umbraco.Cms.Core.Models.Trees;
 public sealed class ExportMember : ActionMenuItem
 {
     public ExportMember(ILocalizedTextService textService)
-        : base("export", textService) => Icon = "download-alt";
+        : base("export", textService)
+    {
+        Icon = "icon-download-alt";
+        UseLegacyIcon = false;
+    }
 
     public override string AngularServiceName => "umbracoMenuActions";
 }
diff --git a/src/Umbraco.Core/Models/Trees/MenuItem.cs b/src/Umbraco.Core/Models/Trees/MenuItem.cs
index 3f77ccf2b6..e99e0d598a 100644
--- a/src/Umbraco.Core/Models/Trees/MenuItem.cs
+++ b/src/Umbraco.Core/Models/Trees/MenuItem.cs
@@ -8,7 +8,7 @@ using Umbraco.Extensions;
 namespace Umbraco.Cms.Core.Models.Trees;
 
 /// <summary>
-///     A context menu item
+    /// A context menu item
 /// </summary>
 [DataContract(Name = "menuItem", Namespace = "")]
 public class MenuItem
@@ -18,7 +18,7 @@ public class MenuItem
     public MenuItem()
     {
         AdditionalData = new Dictionary<string, object>();
-        Icon = "folder";
+        Icon = Constants.Icons.Folder;
     }
 
     public MenuItem(string alias, string name)
@@ -33,11 +33,11 @@ public class MenuItem
     {
         Alias = alias;
         Name = textService.Localize("actions", Alias);
-        TextDescription = textService.Localize("visuallyHiddenTexts", alias + "_description", Thread.CurrentThread.CurrentUICulture);
+            TextDescription =  textService.Localize("visuallyHiddenTexts", alias + "_description", Thread.CurrentThread.CurrentUICulture);
     }
 
     /// <summary>
-    ///     Create a menu item based on an <see cref="IAction" /> definition
+        /// Create a menu item based on an <see cref="IAction"/> definition
     /// </summary>
     /// <param name="action"></param>
     /// <param name="name"></param>
@@ -81,16 +81,26 @@ public class MenuItem
     public string? TextDescription { get; set; }
 
     /// <summary>
-    ///     Ensures a menu separator will exist before this menu item
+        /// Ensures a menu separator will exist before this menu item
     /// </summary>
     [DataMember(Name = "separator")]
     public bool SeparatorBefore { get; set; }
 
-    [DataMember(Name = "cssclass")]
+    /// <summary>
+    /// Icon to use at action menu item.
+    /// </summary>
+    [DataMember(Name = "icon")]
     public string Icon { get; set; }
 
     /// <summary>
-    ///     Used in the UI to inform the user that the menu item will open a dialog/confirmation
+    /// Used in the UI to indicate whether icons should be prefixed with "icon-".
+    /// If not legacy icon full icon name should be specified.
+    /// </summary>
+    [DataMember(Name = "useLegacyIcon")]
+    public bool UseLegacyIcon { get; set; } = true;
+
+        /// <summary>
+        /// Used in the UI to inform the user that the menu item will open a dialog/confirmation
     /// </summary>
     [DataMember(Name = "opensDialog")]
     public bool OpensDialog { get; set; }
diff --git a/src/Umbraco.Core/Models/Trees/RefreshNode.cs b/src/Umbraco.Core/Models/Trees/RefreshNode.cs
index befbec019e..c10cdfcdf5 100644
--- a/src/Umbraco.Core/Models/Trees/RefreshNode.cs
+++ b/src/Umbraco.Core/Models/Trees/RefreshNode.cs
@@ -1,4 +1,4 @@
-using Umbraco.Cms.Core.Services;
+﻿using Umbraco.Cms.Core.Services;
 
 namespace Umbraco.Cms.Core.Models.Trees;
 
@@ -8,18 +8,22 @@ namespace Umbraco.Cms.Core.Models.Trees;
 /// </summary>
 public sealed class RefreshNode : ActionMenuItem
 {
+    private const string icon = "icon-refresh";
+
     public RefreshNode(string name, bool separatorBefore = false)
         : base("refreshNode", name)
     {
-        Icon = "refresh";
+        Icon = icon;
         SeparatorBefore = separatorBefore;
+        UseLegacyIcon = false;
     }
 
     public RefreshNode(ILocalizedTextService textService, bool separatorBefore = false)
         : base("refreshNode", textService)
     {
-        Icon = "refresh";
+        Icon = icon;
         SeparatorBefore = separatorBefore;
+        UseLegacyIcon = false;
     }
 
     public override string AngularServiceName => "umbracoMenuActions";
diff --git a/src/Umbraco.Core/Persistence/Repositories/IRedirectUrlRepository.cs b/src/Umbraco.Core/Persistence/Repositories/IRedirectUrlRepository.cs
index b6393dfcc0..b7f29edc92 100644
--- a/src/Umbraco.Core/Persistence/Repositories/IRedirectUrlRepository.cs
+++ b/src/Umbraco.Core/Persistence/Repositories/IRedirectUrlRepository.cs
@@ -1,3 +1,4 @@
+﻿using System.Threading.Tasks;
 using Umbraco.Cms.Core.Models;
 
 namespace Umbraco.Cms.Core.Persistence.Repositories;
@@ -44,10 +45,25 @@ public interface IRedirectUrlRepository : IReadWriteQueryRepository<Guid, IRedir
     ///     Gets the most recent redirect URL corresponding to an Umbraco redirect URL route.
     /// </summary>
     /// <param name="url">The Umbraco redirect URL route.</param>
+    /// <returns>The most recent redirect URL corresponding to the route.</returns>
+    Task<IRedirectUrl?> GetMostRecentUrlAsync(string url) => Task.FromResult(GetMostRecentUrl(url));
+
+    /// <summary>
+    /// Gets the most recent redirect URL corresponding to an Umbraco redirect URL route.
+    /// </summary>
+    /// <param name="url">The Umbraco redirect URL route.</param>
     /// <param name="culture">The culture the domain is associated with</param>
     /// <returns>The most recent redirect URL corresponding to the route.</returns>
     IRedirectUrl? GetMostRecentUrl(string url, string culture);
 
+    /// <summary>
+    /// Gets the most recent redirect URL corresponding to an Umbraco redirect URL route.
+    /// </summary>
+    /// <param name="url">The Umbraco redirect URL route.</param>
+    /// <param name="culture">The culture the domain is associated with</param>
+    /// <returns>The most recent redirect URL corresponding to the route.</returns>
+    Task<IRedirectUrl?> GetMostRecentUrlAsync(string url, string culture) => Task.FromResult(GetMostRecentUrl(url, culture));
+
     /// <summary>
     ///     Gets all redirect URLs for a content item.
     /// </summary>
diff --git a/src/Umbraco.Core/PropertyEditors/NestedContentConfiguration.cs b/src/Umbraco.Core/PropertyEditors/NestedContentConfiguration.cs
index a22eb352c0..fdef902b58 100644
--- a/src/Umbraco.Core/PropertyEditors/NestedContentConfiguration.cs
+++ b/src/Umbraco.Core/PropertyEditors/NestedContentConfiguration.cs
@@ -1,4 +1,4 @@
-using System.Runtime.Serialization;
+﻿using System.Runtime.Serialization;
 
 namespace Umbraco.Cms.Core.PropertyEditors;
 
@@ -22,6 +22,9 @@ public class NestedContentConfiguration
     [ConfigurationField("showIcons", "Show Icons", "boolean", Description = "Show the Element Type icons.")]
     public bool ShowIcons { get; set; } = true;
 
+    [ConfigurationField("expandsOnLoad", "Expands on load", "boolean", Description = "A single item is automatically expanded")]
+    public bool ExpandsOnLoad { get; set; } = true;
+
     [ConfigurationField("hideLabel", "Hide Label", "boolean", Description = "Hide the property label and let the item list span the full width of the editor window.")]
     public bool HideLabel { get; set; }
 
